local LibStub = LibStub
local AceAddon = LibStub("AceAddon-3.0")
local AceLocale = LibStub("AceLocale-3.0")
local AceDBOptions = LibStub("AceDBOptions-3.0")
local AceConfig = LibStub("AceConfig-3.0")
local AceConfigDialog = LibStub("AceConfigDialog-3.0")
local ControlPanel = AceAddon:GetAddon("ControlPanel")
local ControlPanel_Options = AceAddon:GetAddon("ControlPanel_Options")
local L = AceLocale:GetLocale("ControlPanel_Options")
local string_format = string.format
local SetCVar = SetCVar

local get_cvar_number = ControlPanel_Options.get_cvar_number

local order = 0
local function get_order()
	local temp = order
	order = order +1
	return temp
end

local scloak
local function showCloak(info,val)
	scloak = val
	ShowCloak(val)
end
local function showingCloak()
	if scloak == nil then
		scloak=ShowingCloak()
	end
	return scloak
end
local shelm
local ShowHelm = ShowHelm
local function showHelm(info,val)
	shelm = val
	ShowHelm(val)
end
local function showingHelm()
	if shelm == nil then
		shelm=ShowingHelm()
	end
	return shelm
end

local Interface =
{
	name = L["Interface"],
	desc = L["ControlPanel won't manage these options."],
	type = "group",
	args =
	{
		Armory =
		{
			name = L["Armory"],
			type = "group",
			args =
			{
				cloak =
				{
					order = get_order(),
					name = L["Cloak"],
					type = "toggle",
					set = showCloak,
					get = showingCloak
				},
				helm =
				{
					order = get_order(),
					name = L["Helm"],
					type = "toggle",
					set = showHelm,
					get = showingHelm
				}
			}
		},
		Camera =
		{
			name = L["Camera"],
			desc = L["These options affect whether certain UI and character elements are hidden or displayed."],
			type = "group",
			args =
			{
				Distance =
				{
					order = get_order(),
					name = L["Distance"],
					type = "group",
					args =
					{
						cameraDistanceMax =
						{
							order = get_order(),
							name = L["Max"],
							type = "range",
							min = 0,
							max = 50,
							set = function(info,val)
								SetCVar("cameraDistanceMax",val)
							end,
							get = function(info)
								return get_cvar_number("cameraDistanceMax")
							end,
						},
						cameraDistanceMaxFactor =
						{
							order = get_order(),
							name = L["Max Factor"],
							type = "range",
							min = 0,
							max = 2,
							set = function(info,val)
								SetCVar("cameraDistanceMaxFactor",val)
							end,
							get = function(info)
								return get_cvar_number("cameraDistanceMaxFactor")
							end,
						},
						cameraDistanceMoveSpeed =
						{
							order = get_order(),
							name = L["Move Speed"],
							type = "range",
							min =  0,
							max = 50,
							set = function(info,val)
								SetCVar("cameraDistanceMoveSpeed",val)
							end,
							get = function(info)
								return get_cvar_number("cameraDistanceMoveSpeed")
							end,
						}
					}
				}
			}
		},
	}
}

ControlPanel_Options:push("Interface",Interface)